UpdateSprites:
; Meteors
	ld	a,(active_meteors)
	or	a
	jr	z,US_Bullets
	ld	b,a

	ld	hl,meteor_array - m_entry_size
	ld	de,m_entry_size
US_MeteorLoop:
	add	hl,de

	ld	a,(hl)
	or	a
	jr	z,US_MeteorLoop

	inc	hl		; -> xpos
	ld	a,(hl)
	inc	hl		; -> xdelta
	add	a,(hl)
	jp	m,US_FlipDelta
	cp	lcd_width - 3
	jr	c,US_NoFlipDelta

US_FlipDelta:
	ld	a,(hl)
	neg
	ld	(hl),a
	dec	hl		; -> xpos
	add	a,(hl)
	inc	hl		; -> xdelta

US_NoFlipDelta:
	dec	hl		; -> xpos
	ld	(hl),a

	inc	hl		; -> xdelta
	inc	hl		; -> ypos

	ld	a,(hl)
	inc	hl		; -> ydelta
	add	a,(hl)
	dec	hl		; -> ypos
	ld	(hl),a

	cp	shield_y * 4
	jp	c,US_NoHitShield

	push	hl
		dec	hl		; -> xdelta
		dec	hl		; -> xpos
		dec	hl		; -> active

		ld	(hl),0
		ld	hl,shield_hp
		dec	(hl)
		dec	hl		;HL -> active_meteors
		dec	(hl)
	pop	hl

US_NoHitShield:
	inc	hl		; -> ydelta
	inc	hl		; -> active
	djnz	US_MeteorLoop + 1

; Bullets
US_Bullets:
	ld	a,(active_bullets)
	or	a
	ret	z
	ld	b,a

	ld	hl,bullet_array - b_entry_size
	ld	de,b_entry_size
US_BulletLoop:
	add	hl,de
	ld	a,(hl)
	or	a
	jr	z,US_BulletLoop
	
	inc	hl		; -> xpos
	inc	hl		; -> ypos
	ld	a,(hl)
	sub	b_delta_y

	jr	nc,US_NoKillBullet
	dec	hl		; -> xpos
	dec	hl		; -> active
	ld	(hl),0
	exx
		ld	hl,active_bullets
		dec	(hl)
	exx

	djnz	US_BulletLoop
	ret

US_NoKillBullet:
	ld	(hl),a
	inc	hl		; -> active
	djnz	US_BulletLoop + 1
	ret

.end